from cherrypy import cpg
from cherrypy.lib.filter import generatorfilter

import cherryflow

class MyController:
    #_cpFilterList = [generatorfilter.GeneratorFilter()]
    #@cpg.expose
    #@flow
    def _miniflow(self, i, j):
        # miniflow exists to demonstrate generator trees
        yield "This is iteration %d. j = %d <a href='?_resume=%d'>Next iteration</a> <a href='?_resume=%d&amp;add=1'>j++</a>" % (i, j, cpg.request.resume_id, cpg.request.resume_id)
    def index(self):
        j = 1
        i = 0
        while True:
            i += 1
            yield self._miniflow(i,j)
            if int(cpg.request.paramMap.get("add", 0)) == 1:
                j += 1
    index = cpg.expose(cherryflow.flow(index)) # py2.3
    def chunked(self):
        yield "hello "
        yield "world "
        yield "<a href='?_resume=%d'>Next</a>" % cpg.request.resume_id
        yield cherryflow.SEND_AND_WAIT
        yield "goodbye "
        yield "world"
        yield cherryflow.SEND_AND_WAIT
    chunked = cpg.expose(cherryflow.chunked_flow(chunked))

if __name__ == "__main__":
    #cherryflow.back_button_error(True)
    cpg.root = MyController()
    cpg.server.start(configDict={'socketPort':8080,'sessionStorageType':'ram'})
    
